<template>
  <div>
    <base-dialog :show='!!error' title='An error occurred' @close="handleError">
      <p>{{error}}</p>
    </base-dialog>
    <base-dialog :show='isLoading' fixed title='Authenticating...'>
      <base-spinner></base-spinner>
    </base-dialog>
    <base-card>
      <form @submit.prevent="submitForm">
        <div class="form-control">
          <label for="email">Email</label>
          <input type="email" name="email" id='email' v-model='email'>
        </div>
        <div class="form-control">
          <label for="password">Password</label>
          <input type="password" name="password" id='password' v-model='password'>
        </div>
        <p v-if="!formIsValid">Please fill all input before submitting.{{formIsValid}}</p>
        <base-button>{{ submitButtonCaption }}</base-button>
        <base-button type="button" mode="flat" @click="switchAuthMode">{{ switchModeButtonCaption }}</base-button>
      </form>
    </base-card>
  </div>
</template>
<script>
export default {
  components: {},

  data(){
    return{
      email: '',
      password:'',
      formIsValid: true,
      mode: 'login',
      isLoading: false,
      error:null
    };
  },
  computed:{
    submitButtonCaption(){
      if(this.mode === 'login'){
        return 'Login';
      }else{
        return 'Signup';
      }
    },
    switchModeButtonCaption(){
      if(this.mode === 'login'){
        return 'Signup instead';
      }else{
        return 'Login instead';
      }
    }
  },
  methods:{
    async submitForm(){
      if(this.email === '' || !this.email.includes('@') ||this.password.length < 6){
        this.formIsValid = false;

        return;
      }
      const actionPayload = {email:this.email,password:this.password};
      this.isLoading = true;
      try {
        if(this.mode === 'login'){
          await this.$store.dispatch('login',actionPayload);
        }else{
          await this.$store.dispatch('signup',actionPayload);
        }
        const redirectUrl = '/'+(this.$route.query.redirect || 'coaches');
        this.$router.replace(redirectUrl);
      }catch (err){
        this.error = err.message || "Failed to authenticate. Try later.";
      }
      this.isLoading = false;
    },
    switchAuthMode(){
      if(this.mode === 'login'){
        this.mode = 'signup';
      }else {
        this.mode = 'login';
      }
    },
    handleError(){
      this.error = null;
    }
  },
}
</script>
<style scoped>
form {
  margin: 1rem;
  border: 1px solid #ccc;
  border-radius: 12px;
  padding: 1rem;
}

.form-control {
  margin: 0.5rem 0;
}

label {
  font-weight: bold;
  margin-bottom: 0.5rem;
  display: block;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  border: 1px solid #ccc;
  padding: 0.15rem;
}

input:focus,
textarea:focus {
  border-color: #3d008d;
  background-color: #faf6ff;
  outline: none;
}

.errors {
  font-weight: bold;
  color: red;
}

.actions {
  text-align: center;
}
</style>